---
product: "AG Grid"
title: "Parsing Values"
description: "After editing cells in the grid you have the opportunity to parse the value before inserting it into your data. This is done using Value Parsers."
framework: react
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-start-stop/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Parsing Values

After editing cells in the grid you have the opportunity to parse the value before inserting it into your data. This is done using Value Parsers.

> **Note**
>
> If using [Cell Data Types](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-data-types/) (which are enabled by default), Value Parsers are automatically set to handle the conversion of each of the basic data types - e.g. `number`, `date`, `boolean`. In this scenario, Value Parsers only need to be defined for object data types, or if the default behaviour needs to be overridden.
>
> The example below assumes Cell Data Types are disabled.

## Value Parser

For example suppose you are editing a number using a text editor. The result will be a `string`, however you will probably want to store the result as a `number`. Use a Value Parser to convert the `string` to a `number`.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        // name is a string, so don't need to convert
        field: 'name',
        editable: true,
    },
    {
        // age is a number, so want to convert from string to number
        field: 'age',
        editable: true,
        valueParser: params => Number(params.newValue)
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueParser` | `string \| ValueParserFunc` |  |  |  |

The return value of a value parser should be the result of the parse, i.e. return the value you want stored in the data.

Below shows an example using value parsers. The following can be noted:

- All columns are editable. After any edit, the console prints the new data for that row.
- Column 'Name' is a string column. No parser is needed.
- Column 'Bad Number' is bad because after an edit, the value is stored as a string in the data, whereas the data value should be number type.
- Column 'Good Number' is good because after an edit, the value is converted to a number using the value parser.

#### Value Parsers

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [TextEditorModule, ClientSideRowModelModule];

function numberParser(params: ValueParserParams) {
  return Number(params.newValue);
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { headerName: "Name", field: "simple" },
    { headerName: "Bad Number", field: "numberBad" },
    {
      headerName: "Good Number",
      field: "numberGood",
      valueParser: numberParser,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      editable: true,
      cellDataType: false,
    };
  }, []);

  const onCellValueChanged = useCallback((event: CellValueChangedEvent) => {
    console.log("data after changes is: ", event.data);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            onCellValueChanged={onCellValueChanged}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Value Parsers](https://www.ag-grid.com/archive/36.2.0/examples/value-parsers/example-parsers/reactFunctionalTs/)

## Use Value Parser for Import

By default, the grid uses the value parser when performing other grid operations that can update values.

This behaviour can be prevented by setting the column definition property `useValueParserForImport = false` (note this does not apply to editing).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `useValueParserForImport` | `boolean` |  |  |  |

Using the value parser for import applies to the following features:

- [Paste](https://www.ag-grid.com/archive/36.2.0/react-data-grid/clipboard/#processing-pasted-data)
- [Fill Handle](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-selection-fill-handle/)
- [Copy Range Down](https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-selection/#copy-cell-range-down)

Using a value parser for import is normally used in conjunction with [Using a Value Formatter for Export](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-formatters/#formatting-for-export), where a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-formatters/) is defined that does the reverse of the value parser.

The following example demonstrates using the value parser for import with each of the supported features mentioned above.

#### Use Value Parser for Import

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  TextEditorModule,
  ValueFormatterParams,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
];

function currencyFormatter(params: ValueFormatterParams) {
  return params.value == null ? "" : "£" + params.value;
}

function currencyParser(params: ValueParserParams) {
  let value = params.newValue;
  if (value == null || value === "") {
    return null;
  }
  value = String(value);
  if (value.startsWith("£")) {
    value = value.slice(1);
  }
  return parseFloat(value);
}

function createRowData() {
  const rowData = [];
  for (let i = 0; i < 100; i++) {
    rowData.push({
      a: Math.floor(((i + 2) * 173456) % 10000),
      b: Math.floor(((i + 7) * 373456) % 10000),
    });
  }
  return rowData;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(createRowData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "£A",
      field: "a",
      valueFormatter: currencyFormatter,
      valueParser: currencyParser,
    },
    {
      headerName: "£B",
      field: "b",
      valueFormatter: currencyFormatter,
      valueParser: currencyParser,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      cellDataType: false,
      editable: true,
    };
  }, []);
  const cellSelection = useMemo<boolean | CellSelectionOptions>(() => {
    return {
      handle: {
        mode: "fill",
      },
    };
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={cellSelection}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/examples/value-parsers/use-value-parser-for-import/reactFunctionalTs/)

Note that if you are providing your own custom handling for the following features, then `useValueParserForImport` is ignored and the value will be either the original value or that set in the custom handler:

- If `processCellFromClipboard` is provided when using paste.
- If `fillOperation` is provided when using fill handle.
- If `processCellFromClipboard` is provided when using copy range down.


---
product: "AG Grid"
title: "Parsing Values"
description: "After editing cells in the grid you have the opportunity to parse the value before inserting it into your data. This is done using Value Parsers."
framework: angular
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-start-stop/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Parsing Values

After editing cells in the grid you have the opportunity to parse the value before inserting it into your data. This is done using Value Parsers.

> **Note**
>
> If using [Cell Data Types](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-data-types/) (which are enabled by default), Value Parsers are automatically set to handle the conversion of each of the basic data types - e.g. `number`, `date`, `boolean`. In this scenario, Value Parsers only need to be defined for object data types, or if the default behaviour needs to be overridden.
>
> The example below assumes Cell Data Types are disabled.

## Value Parser

For example suppose you are editing a number using a text editor. The result will be a `string`, however you will probably want to store the result as a `number`. Use a Value Parser to convert the `string` to a `number`.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        // name is a string, so don't need to convert
        field: 'name',
        editable: true,
    },
    {
        // age is a number, so want to convert from string to number
        field: 'age',
        editable: true,
        valueParser: params => Number(params.newValue)
    }
];
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueParser` | `string \| ValueParserFunc` |  |  |  |

The return value of a value parser should be the result of the parse, i.e. return the value you want stored in the data.

Below shows an example using value parsers. The following can be noted:

- All columns are editable. After any edit, the console prints the new data for that row.
- Column 'Name' is a string column. No parser is needed.
- Column 'Bad Number' is bad because after an edit, the value is stored as a string in the data, whereas the data value should be number type.
- Column 'Good Number' is good because after an edit, the value is converted to a number using the value parser.

#### Value Parsers

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([TextEditorModule, ClientSideRowModelModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (cellValueChanged)="onCellValueChanged($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { headerName: "Name", field: "simple" },
    { headerName: "Bad Number", field: "numberBad" },
    {
      headerName: "Good Number",
      field: "numberGood",
      valueParser: numberParser,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    editable: true,
    cellDataType: false,
  };
  rowData: any[] | null = getData();

  onCellValueChanged(event: CellValueChangedEvent) {
    console.log("data after changes is: ", event.data);
  }
}

function numberParser(params: ValueParserParams) {
  return Number(params.newValue);
}
```

[Live example: Value Parsers](https://www.ag-grid.com/archive/36.2.0/examples/value-parsers/example-parsers/angular/)

## Use Value Parser for Import

By default, the grid uses the value parser when performing other grid operations that can update values.

This behaviour can be prevented by setting the column definition property `useValueParserForImport = false` (note this does not apply to editing).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `useValueParserForImport` | `boolean` |  |  |  |

Using the value parser for import applies to the following features:

- [Paste](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/clipboard/#processing-pasted-data)
- [Fill Handle](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-selection-fill-handle/)
- [Copy Range Down](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-selection/#copy-cell-range-down)

Using a value parser for import is normally used in conjunction with [Using a Value Formatter for Export](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-formatters/#formatting-for-export), where a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-formatters/) is defined that does the reverse of the value parser.

The following example demonstrates using the value parser for import with each of the supported features mentioned above.

#### Use Value Parser for Import

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextEditorModule,
  ValueFormatterParams,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    [cellSelection]="cellSelection"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      headerName: "£A",
      field: "a",
      valueFormatter: currencyFormatter,
      valueParser: currencyParser,
    },
    {
      headerName: "£B",
      field: "b",
      valueFormatter: currencyFormatter,
      valueParser: currencyParser,
    },
  ];
  defaultColDef: ColDef = {
    cellDataType: false,
    editable: true,
  };
  rowData: any[] | null = createRowData();
  cellSelection: boolean | CellSelectionOptions = {
    handle: {
      mode: "fill",
    },
  };
}

function currencyFormatter(params: ValueFormatterParams) {
  return params.value == null ? "" : "£" + params.value;
}
function currencyParser(params: ValueParserParams) {
  let value = params.newValue;
  if (value == null || value === "") {
    return null;
  }
  value = String(value);
  if (value.startsWith("£")) {
    value = value.slice(1);
  }
  return parseFloat(value);
}
function createRowData() {
  const rowData = [];
  for (let i = 0; i < 100; i++) {
    rowData.push({
      a: Math.floor(((i + 2) * 173456) % 10000),
      b: Math.floor(((i + 7) * 373456) % 10000),
    });
  }
  return rowData;
}
```

[Live example: Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/examples/value-parsers/use-value-parser-for-import/angular/)

Note that if you are providing your own custom handling for the following features, then `useValueParserForImport` is ignored and the value will be either the original value or that set in the custom handler:

- If `processCellFromClipboard` is provided when using paste.
- If `fillOperation` is provided when using fill handle.
- If `processCellFromClipboard` is provided when using copy range down.


---
product: "AG Grid"
title: "Parsing Values"
description: "After editing cells in the grid you have the opportunity to parse the value before inserting it into your data. This is done using Value Parsers."
framework: vue
version: "36.2.0"
related:
    - title: "Overview"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing/"
    - title: "Start / Stop Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-start-stop/"
    - title: "Saving Values"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-setters/"
    - title: "Edit Components"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editors/"
    - title: "Provided Cell Editors"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/provided-cell-editors/"
    - title: "Undo / Redo Edits"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/undo-redo-edits/"
    - title: "Full Row"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-full-row/"
    - title: "Validation"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-validation/"
    - title: "Batch Editing"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-editing-batch/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Parsing Values

After editing cells in the grid you have the opportunity to parse the value before inserting it into your data. This is done using Value Parsers.

> **Note**
>
> If using [Cell Data Types](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-data-types/) (which are enabled by default), Value Parsers are automatically set to handle the conversion of each of the basic data types - e.g. `number`, `date`, `boolean`. In this scenario, Value Parsers only need to be defined for object data types, or if the default behaviour needs to be overridden.
>
> The example below assumes Cell Data Types are disabled.

## Value Parser

For example suppose you are editing a number using a text editor. The result will be a `string`, however you will probably want to store the result as a `number`. Use a Value Parser to convert the `string` to a `number`.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        // name is a string, so don't need to convert
        field: 'name',
        editable: true,
    },
    {
        // age is a number, so want to convert from string to number
        field: 'age',
        editable: true,
        valueParser: params => Number(params.newValue)
    }
];
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueParser` | `string \| ValueParserFunc` |  |  |  |

The return value of a value parser should be the result of the parse, i.e. return the value you want stored in the data.

Below shows an example using value parsers. The following can be noted:

- All columns are editable. After any edit, the console prints the new data for that row.
- Column 'Name' is a string column. No parser is needed.
- Column 'Bad Number' is bad because after an edit, the value is stored as a string in the data, whereas the data value should be number type.
- Column 'Good Number' is good because after an edit, the value is converted to a number using the value parser.

#### Value Parsers

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextEditorModule,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([TextEditorModule, ClientSideRowModelModule]);

function numberParser(params: ValueParserParams) {
  return Number(params.newValue);
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"
      @cell-value-changed="onCellValueChanged"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { headerName: "Name", field: "simple" },
      { headerName: "Bad Number", field: "numberBad" },
      {
        headerName: "Good Number",
        field: "numberGood",
        valueParser: numberParser,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      editable: true,
      cellDataType: false,
    });
    const rowData = ref<any[] | null>(getData());

    function onCellValueChanged(event: CellValueChangedEvent) {
      console.log("data after changes is: ", event.data);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onCellValueChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Value Parsers](https://www.ag-grid.com/archive/36.2.0/examples/value-parsers/example-parsers/vue3/)

## Use Value Parser for Import

By default, the grid uses the value parser when performing other grid operations that can update values.

This behaviour can be prevented by setting the column definition property `useValueParserForImport = false` (note this does not apply to editing).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `useValueParserForImport` | `boolean` |  |  |  |

Using the value parser for import applies to the following features:

- [Paste](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/clipboard/#processing-pasted-data)
- [Fill Handle](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-selection-fill-handle/)
- [Copy Range Down](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-selection/#copy-cell-range-down)

Using a value parser for import is normally used in conjunction with [Using a Value Formatter for Export](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-formatters/#formatting-for-export), where a [Value Formatter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-formatters/) is defined that does the reverse of the value parser.

The following example demonstrates using the value parser for import with each of the supported features mentioned above.

#### Use Value Parser for Import

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  TextEditorModule,
  ValueFormatterParams,
  ValueParserParams,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
]);

function currencyFormatter(params: ValueFormatterParams) {
  return params.value == null ? "" : "£" + params.value;
}

function currencyParser(params: ValueParserParams) {
  let value = params.newValue;
  if (value == null || value === "") {
    return null;
  }
  value = String(value);
  if (value.startsWith("£")) {
    value = value.slice(1);
  }
  return parseFloat(value);
}

function createRowData() {
  const rowData = [];
  for (let i = 0; i < 100; i++) {
    rowData.push({
      a: Math.floor(((i + 2) * 173456) % 10000),
      b: Math.floor(((i + 7) * 373456) % 10000),
    });
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"
      :cellSelection="cellSelection"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "£A",
        field: "a",
        valueFormatter: currencyFormatter,
        valueParser: currencyParser,
      },
      {
        headerName: "£B",
        field: "b",
        valueFormatter: currencyFormatter,
        valueParser: currencyParser,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      cellDataType: false,
      editable: true,
    });
    const rowData = ref<any[] | null>(createRowData());
    const cellSelection = ref<boolean | CellSelectionOptions>({
      handle: {
        mode: "fill",
      },
    });

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      cellSelection,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Use Value Parser for Import](https://www.ag-grid.com/archive/36.2.0/examples/value-parsers/use-value-parser-for-import/vue3/)

Note that if you are providing your own custom handling for the following features, then `useValueParserForImport` is ignored and the value will be either the original value or that set in the custom handler:

- If `processCellFromClipboard` is provided when using paste.
- If `fillOperation` is provided when using fill handle.
- If `processCellFromClipboard` is provided when using copy range down.
